include("rejection_chains.jl")


function Base.show(io::IO, c::RejectionChains)
    print(io, "Chains (×$(length(c))) {", eltype(c), "}")
end

function Base.display(c::RejectionChains)
    println(c)
    data = info(c)
    for k in keys(data)
        if length(c) == 1
            println(" ", k, " : ", data[k][1])
        else
            m, s = mean(data[k]), std(data[k])
            m = round(m, sigdigits=5)
            s = round(s, sigdigits=3)
            println(" ", k, " : ", m, " ± ", s)
        end
    end
end


#=abstract type AbstractRejectionChains <: AbstractMCMC.AbstractChains end

#include("simple.jl")
#include("multi.jl")

#=
struct RejectionChains{X, L, R, I} <: AbstractRejectionChains
    states::Matrix{X}
    logprobs::Matrix{L}
    rejections::Matrix{R}
end

eltype(c::RejectionChains{X,L,R}) where {X,L,R} = X 
size(c::RejectionChains, args...) = size(c.states, args...)

function getindex(c::RejectionChains, n, m )
    return RejectionChains(
        c.states[n, m],
        c.logprobs[n, m],
        c.rejections[n, m]
    )
end

function states(c::RejectionChains)
    return fill.(c.states, c.rejections)
end

function get_info(c::RejectionChains)
    s = size(c)
    rejection_rate
    (; )
end
=#

function Base.show(io::IO, c::RejectionBasedChains)
    print(io, "Chain ", size(c), " {", eltype(c), "}")
end

function Base.display(c::RejectionBasedChains)
    println(c)
    info = get_info(c)
    nchains = size(c, 2)
    for k = keys(info)
        if nchains == 1
            println(" ", k, " : ", info[k][1])
        else
            m, s = mean(info[k]), std(info[k])
            println(" ", k, " : ", m, " ± ", s)
        end
    end
end
=#